/*
 * AlibavaMonitor.h
 *
 *  Created on: Jul 20, 2012
 *      Author: lacasta
 */

#ifndef ALIBAVAMONITOR_H_
#define ALIBAVAMONITOR_H_
#include <string>


class AlibavaMonitor
{
    private:
        std::string _time_elapsed;
        std::string _rate;
        std::string _run_type;
        std::string _out_file;

        int    _run_type_val;
        int    _ntrigger;
        int    _nexpected;
        int    _naccepted;
        double _fraction;
        double _ratef;
        double _value;
        bool   _start_from_soap;

        double _ntrig0;
        double _tim0;
        void   *_data;
    public:
        AlibavaMonitor();
        virtual ~AlibavaMonitor();
        double getFraction() const;
        int getNtrigger() const;
        const std::string& getOutFile() const;
        const std::string& getRate() const;
        double getRateAsNumber() const;
        const std::string& getTimeElapsed() const;
        void getHistogram(const std::string &whst, size_t &size, char **buffer);
        const std::string& getRunType() const;
        int getRunTypeVal() const;
        void setRunTypeVal( int v );
        int getNexpected() const;
        void setData(void* data);
        void setFraction(double fraction);
        void setNtrigger(int ntrigger);
        void setOutFile(const std::string& outFile);
        void setRate(const std::string& rate);
        void setRate(const double val);
        void setTimeElapsed(const std::string& timeElapsed);
        void setRunType(const std::string& runType);
        void setNexpected(int nexpected);
        double getValue() const;
        void setValue(double value);
        void from_soap(bool x) {_start_from_soap = x; }
        bool from_soap() const { return _start_from_soap; }
        void reset_counters();
        double getNtrig0() const;
        void setNtrig0(double ntrig0);
        double getTim0() const;
        void setTim0(double tim0);
        int getNaccepted() const;
        void setNaccepted(int naccepted);
        double getEfficiency() const;
        std::string getEfficiencyAsString(int set_prec=1) const;
};

#endif /* ALIBAVAMONITOR_H_ */
